#pragma once
#include "Player.h"
#include "NPVRSession.h"

class PlayerLive: public Player
{
public:
	PlayerLive(NPVRSession *session, int channelOID, PlayerDelegate* playerDelegate, char* url, SDL_Renderer* renderer, SDL_Texture* videoTexture, SDL_mutex* mutex, bool useServerSkip, int forcedDuration, int64_t forceSize, bool useGPU);
	~PlayerLive(void);

	bool StartStream(int64_t offset = 0);
	void StopStream();
	void RenewLease();

	void Tick() override;
		
	void Seek(int ms, int duration = 0) override;

private:
	NPVRSession* session;
	char baseURL[512];	
	char sid[128];
	char clientID[96];
	int channelOID;
	time_t lastRenewTime;
};